<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperServerMain.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZooKeeperServerMain.java</span></div><h1>ZooKeeperServerMain.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.File;
import java.io.IOException;

import javax.management.JMException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.jmx.ManagedUtil;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.quorum.QuorumPeerConfig.ConfigException;

/**
 * This class starts and runs a standalone ZooKeeperServer.
 */
<span class="fc" id="L35">public class ZooKeeperServerMain {</span>
<span class="fc" id="L36">    private static final Logger LOG =</span>
<span class="fc" id="L37">        LoggerFactory.getLogger(ZooKeeperServerMain.class);</span>

    private static final String USAGE =
        &quot;Usage: ZooKeeperServerMain configfile | port datadir [ticktime] [maxcnxns]&quot;;

    private ServerCnxnFactory cnxnFactory;

    /*
     * Start up the ZooKeeper server.
     *
     * @param args the configfile or the port datadir [ticktime]
     */
    public static void main(String[] args) {
<span class="fc" id="L50">        ZooKeeperServerMain main = new ZooKeeperServerMain();</span>
        try {
<span class="nc" id="L52">            main.initializeAndRun(args);</span>
<span class="nc" id="L53">        } catch (IllegalArgumentException e) {</span>
<span class="nc" id="L54">            LOG.error(&quot;Invalid arguments, exiting abnormally&quot;, e);</span>
<span class="nc" id="L55">            LOG.info(USAGE);</span>
<span class="nc" id="L56">            System.err.println(USAGE);</span>
<span class="nc" id="L57">            System.exit(2);</span>
<span class="nc" id="L58">        } catch (ConfigException e) {</span>
<span class="nc" id="L59">            LOG.error(&quot;Invalid config, exiting abnormally&quot;, e);</span>
<span class="nc" id="L60">            System.err.println(&quot;Invalid config, exiting abnormally&quot;);</span>
<span class="nc" id="L61">            System.exit(2);</span>
<span class="nc" id="L62">        } catch (Exception e) {</span>
<span class="nc" id="L63">            LOG.error(&quot;Unexpected exception, exiting abnormally&quot;, e);</span>
<span class="nc" id="L64">            System.exit(1);</span>
<span class="nc" id="L65">        }</span>
<span class="nc" id="L66">        LOG.info(&quot;Exiting normally&quot;);</span>
<span class="nc" id="L67">        System.exit(0);</span>
<span class="nc" id="L68">    }</span>

    protected void initializeAndRun(String[] args)
        throws ConfigException, IOException
    {
        try {
<span class="fc" id="L74">            ManagedUtil.registerLog4jMBeans();</span>
<span class="fc" id="L75">        } catch (JMException e) {</span>
<span class="fc" id="L76">            LOG.warn(&quot;Unable to register log4j JMX control&quot;, e);</span>
<span class="fc" id="L77">        }</span>

<span class="fc" id="L79">        ServerConfig config = new ServerConfig();</span>
<span class="pc bpc" id="L80" title="1 of 2 branches missed.">        if (args.length == 1) {</span>
<span class="fc" id="L81">            config.parse(args[0]);</span>
        } else {
<span class="nc" id="L83">            config.parse(args);</span>
        }

<span class="fc" id="L86">        runFromConfig(config);</span>
<span class="fc" id="L87">    }</span>

    /**
     * Run from a ServerConfig.
     * @param config ServerConfig to use.
     * @throws IOException
     */
    public void runFromConfig(ServerConfig config) throws IOException {
<span class="fc" id="L95">        LOG.info(&quot;Starting server&quot;);</span>
<span class="fc" id="L96">        FileTxnSnapLog txnLog = null;</span>
        try {
            // Note that this thread isn't going to be doing anything else,
            // so rather than spawning another thread, we will just call
            // run() in this thread.
            // create a file logger url from the command line args
<span class="fc" id="L102">            ZooKeeperServer zkServer = new ZooKeeperServer();</span>

<span class="fc" id="L104">            txnLog = new FileTxnSnapLog(new File(config.dataLogDir), new File(</span>
                    config.dataDir));
<span class="fc" id="L106">            zkServer.setTxnLogFactory(txnLog);</span>
<span class="fc" id="L107">            zkServer.setTickTime(config.tickTime);</span>
<span class="fc" id="L108">            zkServer.setMinSessionTimeout(config.minSessionTimeout);</span>
<span class="fc" id="L109">            zkServer.setMaxSessionTimeout(config.maxSessionTimeout);</span>
<span class="fc" id="L110">            cnxnFactory = ServerCnxnFactory.createFactory();</span>
<span class="fc" id="L111">            cnxnFactory.configure(config.getClientPortAddress(),</span>
<span class="fc" id="L112">                    config.getMaxClientCnxns());</span>
<span class="fc" id="L113">            cnxnFactory.startup(zkServer);</span>
<span class="fc" id="L114">            cnxnFactory.join();</span>
<span class="pc bpc" id="L115" title="1 of 2 branches missed.">            if (zkServer.isRunning()) {</span>
<span class="fc" id="L116">                zkServer.shutdown();</span>
            }
<span class="pc" id="L118">        } catch (InterruptedException e) {</span>
            // warn, but generally this is ok
<span class="nc" id="L120">            LOG.warn(&quot;Server interrupted&quot;, e);</span>
<span class="nc" id="L121">        } finally {</span>
<span class="nc" id="L122">            if (txnLog != null) {</span>
<span class="pc bnc" id="L123" title="All 4 branches missed.">                txnLog.close();</span>
            }
<span class="pc" id="L125">        }</span>
<span class="pc bpc" id="L126" title="1 of 2 branches missed.">    }</span>

    /**
     * Shutdown the serving instance
     */
    protected void shutdown() {
<span class="fc" id="L132">        cnxnFactory.shutdown();</span>
<span class="fc" id="L133">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>